<html>
<head>
<title>OgreHighLevelGpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreHighLevelGpuProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreHighLevelGpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __HighLevelGpuProgram_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __HighLevelGpuProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 
<a name="l00063"></a><a class="code" href="classOgre_1_1HighLevelGpuProgram.html">00063</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>
<a name="l00064"></a>00064     {
<a name="l00065"></a>00065     <span class="keyword">protected</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1HighLevelGpuProgram.html#aef2805cb089810b6149fcf1ae7491618">00067</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html#aef2805cb089810b6149fcf1ae7491618" title="Whether the high-level program (and it&#39;s parameter defs) is loaded.">mHighLevelLoaded</a>;
<a name="l00069"></a><a class="code" href="classOgre_1_1HighLevelGpuProgram.html#a6750d4ca21e40df5b389b0da1eb97ad2">00069</a>         <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html#a6750d4ca21e40df5b389b0da1eb97ad2" title="The underlying assembler program.">mAssemblerProgram</a>;
<a name="l00071"></a><a class="code" href="classOgre_1_1HighLevelGpuProgram.html#a19740a9a6c90ef1f945cf9505d5b8bd3">00071</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html#a19740a9a6c90ef1f945cf9505d5b8bd3" title="Have we built the name-&gt;index parameter map yet?">mConstantDefsBuilt</a>;
<a name="l00072"></a>00072 
<a name="l00074"></a>00074         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadHighLevel(<span class="keywordtype">void</span>);
<a name="l00076"></a>00076         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadHighLevel(<span class="keywordtype">void</span>);
<a name="l00080"></a>00080         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadHighLevelImpl(<span class="keywordtype">void</span>);
<a name="l00083"></a>00083         <span class="keyword">virtual</span> <span class="keywordtype">void</span> createLowLevelImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00085"></a>00085         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadHighLevelImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00087"></a>00087         <span class="keyword">virtual</span> <span class="keywordtype">void</span> populateParameterNames(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params);
<a name="l00094"></a>00094         <span class="keyword">virtual</span> <span class="keywordtype">void</span> buildConstantDefinitions() <span class="keyword">const</span> = 0;
<a name="l00095"></a>00095 
<a name="l00097"></a>00097         <span class="keywordtype">void</span> loadImpl();
<a name="l00099"></a>00099         <span class="keywordtype">void</span> unloadImpl();
<a name="l00100"></a>00100     <span class="keyword">public</span>:
<a name="l00102"></a>00102         <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00103"></a>00103             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00104"></a>00104         ~<a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>();
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00114"></a>00114         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> createParameters(<span class="keywordtype">void</span>);
<a name="l00116"></a><a class="code" href="classOgre_1_1HighLevelGpuProgram.html#a3738e5bfb9a287279bbbbfa0271bc05c">00116</a>         <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* <a class="code" href="classOgre_1_1HighLevelGpuProgram.html#a3738e5bfb9a287279bbbbfa0271bc05c">_getBindingDelegate</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mAssemblerProgram.getPointer(); }
<a name="l00117"></a>00117 
<a name="l00122"></a>00122         <span class="keyword">const</span> <a class="code" href="structOgre_1_1GpuNamedConstants.html" title="Struct collecting together the information for named constants.">GpuNamedConstants</a>&amp; getConstantDefinitions() <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00125"></a><a class="code" href="classOgre_1_1HighLevelGpuProgram.html#ad2fa680be2838aab998079e0bcdeba89">00125</a>         <span class="keyword">const</span> <a class="code" href="structOgre_1_1GpuNamedConstants.html" title="Struct collecting together the information for named constants.">GpuNamedConstants</a>&amp; <a class="code" href="classOgre_1_1HighLevelGpuProgram.html#ad2fa680be2838aab998079e0bcdeba89" title="Override GpuProgram::getNamedConstants to ensure built.">getNamedConstants</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> getConstantDefinitions(); }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     };
<a name="l00132"></a>00132 
<a name="l00139"></a><a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html">00139</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;HighLevelGpuProgram&gt; 
<a name="l00140"></a>00140     {
<a name="l00141"></a>00141     <span class="keyword">public</span>:
<a name="l00142"></a><a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html#ac6c689d11943ba3d54c0feca4e495af2">00142</a>         <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html#ac6c689d11943ba3d54c0feca4e495af2">HighLevelGpuProgramPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>&gt;() {}
<a name="l00143"></a><a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html#a16792345ea8cde8a6f3a3d92360de3b4">00143</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html#a16792345ea8cde8a6f3a3d92360de3b4">HighLevelGpuProgramPtr</a>(<a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>&gt;(rep) {}
<a name="l00144"></a><a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html#a0d2eaea4f2556f9e29734813d36ca4fd">00144</a>         <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html#a0d2eaea4f2556f9e29734813d36ca4fd">HighLevelGpuProgramPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>&gt;(r) {} 
<a name="l00145"></a><a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html#a655836382c180b9b7a43eeca469ce829">00145</a>         <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>&gt;()
<a name="l00146"></a>00146         {
<a name="l00147"></a>00147             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00148"></a>00148             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00149"></a>00149             {
<a name="l00150"></a>00150                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00151"></a>00151                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00152"></a>00152                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00153"></a>00153                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00154"></a>00154                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00155"></a>00155                 {
<a name="l00156"></a>00156                     ++(*pUseCount);
<a name="l00157"></a>00157                 }
<a name="l00158"></a>00158             }
<a name="l00159"></a>00159         }
<a name="l00160"></a>00160 
<a name="l00162"></a><a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html#a4b59cf9327408396b9e7d0c51d5045fc">00162</a>         <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00163"></a>00163         {
<a name="l00164"></a>00164             <span class="keywordflow">if</span> (pRep == static_cast&lt;HighLevelGpuProgram*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00165"></a>00165                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00166"></a>00166             release();
<a name="l00167"></a>00167             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00168"></a>00168             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00169"></a>00169             {
<a name="l00170"></a>00170                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00171"></a>00171                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00172"></a>00172                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00173"></a>00173                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00174"></a>00174                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00175"></a>00175                 {
<a name="l00176"></a>00176                     ++(*pUseCount);
<a name="l00177"></a>00177                 }
<a name="l00178"></a>00178             }
<a name="l00179"></a>00179             <span class="keywordflow">else</span>
<a name="l00180"></a>00180             {
<a name="l00181"></a>00181                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00182"></a>00182                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00183"></a>00183                 setNull();
<a name="l00184"></a>00184             }
<a name="l00185"></a>00185             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00186"></a>00186         }
<a name="l00188"></a>00188         <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; r);
<a name="l00189"></a>00189     };
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
